package fxHarakka.luokat;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Optional;

/**
 * --------------------Tehtavat == (monikko) tehtävien luokka----------------
 * |                                                    | - Tehtävä         |
 * | -Lisää ja poistaa tehtäviä.                        |                   |
 * | -Huolehtii listan pituuden riittävyydestä jos      |                   |
 *    täyttyy.                                          |                   |
 * | -Lukee ja kirjoittaa tapahtumat.dat tiedostoa.     |                   |
 * | -Etsii ja lajittelee(avustaja tehtävä).            |                   |
 * |                                                    |                   |
 * |                                                    |                   |
 * --------------------------------------------------------------------------
 */
public class Tehtavat {
    private int maara = 0;
    private int maxMaara = 10;
    private int id;
    private String tiedostoNimi = "";
    private Tehtava tahtavaAlkiot[] = new Tehtava[maxMaara];

    //-----------------------MUODOSTAJAT-TEHTAVAT----------------------------


    //ei tarvitse erikseen muodostajia
    public Tehtavat() {

    }


    //-----------------------METODIT - TEHTAVAT----------------------------

    /**
     * @return palauttaa tehtävien määrän
     */
    public int getMaara() {
        return maara;
    }


    /**
     * Lisää tehtävä jäsenen tietorakenteeseen
     * @param tehtava lisättävä tehtävä
     */
    public void lisaaTehtava (Tehtava tehtava) {
            tahtavaAlkiot[maara++] = tehtava;
    }


    /**
     * poistaa tehtävän tietorakenteesta indeksin perusteella
     * @param tehtava poistettava tehtävä
     */
    public void poistaTehtava (Tehtava tehtava) {

        for (int i = 0; i < maxMaara; i++) {
            if (tahtavaAlkiot[i] == tehtava && i < maxMaara - 1) {
                for (int j = i; j < maxMaara-1; j++) {
                    tahtavaAlkiot[i] = tahtavaAlkiot[i+1];
                }
            }
        }

    }



    /**
     * @return Tehtävä
     * @param i Tehtävän indeksi tietorakenteessa joka halutaan
     */
    public Tehtava anna (int i) {
       return tahtavaAlkiot[i];
    }


    /**
     * Tallentaa tehtävän rekisteriin
     */
    public void tallenna () {
    }





    /**
     * Testipääohjelma
     * @param args ei käytössä
     */
    public static void main(String args[]) {
        Tehtavat tehtavat = new Tehtavat();

        Tehtava labratyo1 = new Tehtava();
        Tehtava luento1 = new Tehtava();

        try {
            tehtavat.lisaaTehtava(labratyo1);
            tehtavat.lisaaTehtava(luento1);
            tehtavat.poistaTehtava(luento1);
            System.out.println("============= Tehtävät testi =================");

            for (int i = 0; i < tehtavat.getMaara(); i++) {
                Tehtava tehtava = tehtavat.anna(i);
                System.out.println("Tehtävä numero: " + i);

            }

        } catch (Exception e) {
            System.out.println("jasen olio ei palauta alkiota" + e.getMessage());
        }

    }




}
